# coding: utf-8

"""
    Midgard Public API

    The Midgard Public API queries THORChain and any chains linked via the Bifröst and prepares information about the network to be readily available for public users. The API parses transaction event data from THORChain and stores them in a time-series database to make time-dependent queries easy. Midgard does not hold critical information. To interact with BEPSwap and Asgardex, users should query THORChain directly.  # noqa: E501

    OpenAPI spec version: 1.0.0-oas3
    Contact: devs@thorchain.org
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class AssetDetail(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'asset': 'Asset',
        'date_created': 'int',
        'price_rune': 'str'
    }

    attribute_map = {
        'asset': 'asset',
        'date_created': 'dateCreated',
        'price_rune': 'priceRune'
    }

    def __init__(self, asset=None, date_created=None, price_rune=None):  # noqa: E501
        """AssetDetail - a model defined in Swagger"""  # noqa: E501
        self._asset = None
        self._date_created = None
        self._price_rune = None
        self.discriminator = None
        if asset is not None:
            self.asset = asset
        if date_created is not None:
            self.date_created = date_created
        if price_rune is not None:
            self.price_rune = price_rune

    @property
    def asset(self):
        """Gets the asset of this AssetDetail.  # noqa: E501


        :return: The asset of this AssetDetail.  # noqa: E501
        :rtype: Asset
        """
        return self._asset

    @asset.setter
    def asset(self, asset):
        """Sets the asset of this AssetDetail.


        :param asset: The asset of this AssetDetail.  # noqa: E501
        :type: Asset
        """

        self._asset = asset

    @property
    def date_created(self):
        """Gets the date_created of this AssetDetail.  # noqa: E501


        :return: The date_created of this AssetDetail.  # noqa: E501
        :rtype: int
        """
        return self._date_created

    @date_created.setter
    def date_created(self, date_created):
        """Sets the date_created of this AssetDetail.


        :param date_created: The date_created of this AssetDetail.  # noqa: E501
        :type: int
        """

        self._date_created = date_created

    @property
    def price_rune(self):
        """Gets the price_rune of this AssetDetail.  # noqa: E501


        :return: The price_rune of this AssetDetail.  # noqa: E501
        :rtype: str
        """
        return self._price_rune

    @price_rune.setter
    def price_rune(self, price_rune):
        """Sets the price_rune of this AssetDetail.


        :param price_rune: The price_rune of this AssetDetail.  # noqa: E501
        :type: str
        """

        self._price_rune = price_rune

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AssetDetail, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AssetDetail):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
